var Q = Object.defineProperty;
var X = (s, e, t) => e in s ? Q(s, e, { enumerable: !0, configurable: !0, writable: !0, value: t }) : s[e] = t;
var E = (s, e, t) => X(s, typeof e != "symbol" ? e + "" : e, t);
import { defineComponent as W, openBlock as R, createElementBlock as j, normalizeClass as G, ref as U, shallowRef as z, watch as Y, toRaw as Z, createElementVNode as ee, createVNode as te, createTextVNode as ne, createCommentVNode as re } from "vue";
const ie = /* @__PURE__ */ W({
  __name: "Loading",
  props: {
    dark: { type: Boolean, default: !1 }
  },
  setup(s) {
    return (e, t) => (R(), j("span", {
      class: G(["cf-player__loader", { "cf-player__loader--dark": e.dark }])
    }, null, 2));
  }
});
/**
  postmate - A powerful, simple, promise-based postMessage library
  @version v1.6.0
  @link https://github.com/dollarshaveclub/postmate
  @author Jacob Kelley <jakie8@gmail.com>
  @license MIT
**/
var v = "application/x-postmate-v1+json", se = 5, ae = 0, oe = function() {
  return ++ae;
}, c = function() {
  var e;
  return g.debug ? (e = console).log.apply(e, arguments) : null;
}, le = function(e) {
  var t = document.createElement("a");
  t.href = e;
  var n = t.protocol.length > 4 ? t.protocol : window.location.protocol, r = t.host.length ? t.port === "80" || t.port === "443" ? t.hostname : t.host : window.location.host;
  return t.origin || n + "//" + r;
}, de = {
  handshake: 1,
  "handshake-reply": 1,
  call: 1,
  emit: 1,
  reply: 1,
  request: 1
  /**
   * Ensures that a message is safe to interpret
   * @param  {Object} message The postmate message being sent
   * @param  {String|Boolean} allowedOrigin The whitelisted origin or false to skip origin check
   * @return {Boolean}
   */
}, B = function(e, t) {
  return !(typeof t == "string" && e.origin !== t || !e.data || typeof e.data == "object" && !("postmate" in e.data) || e.data.type !== v || !de[e.data.postmate]);
}, ce = function(e, t) {
  var n = typeof e[t] == "function" ? e[t]() : e[t];
  return g.Promise.resolve(n);
}, fe = /* @__PURE__ */ function() {
  function s(t) {
    var n = this;
    this.parent = t.parent, this.frame = t.frame, this.child = t.child, this.childOrigin = t.childOrigin, this.events = {}, process.env.NODE_ENV !== "production" && (c("Parent: Registering API"), c("Parent: Awaiting messages...")), this.listener = function(r) {
      if (!B(r, n.childOrigin)) return !1;
      var o = ((r || {}).data || {}).value || {}, i = o.data, a = o.name;
      r.data.postmate === "emit" && (process.env.NODE_ENV !== "production" && c("Parent: Received event emission: " + a), a in n.events && n.events[a].forEach(function(l) {
        l.call(n, i);
      }));
    }, this.parent.addEventListener("message", this.listener, !1), process.env.NODE_ENV !== "production" && c("Parent: Awaiting event emissions from Child");
  }
  var e = s.prototype;
  return e.get = function(n) {
    var r = this;
    return new g.Promise(function(o) {
      var i = oe(), a = function l(d) {
        d.data.uid === i && d.data.postmate === "reply" && (r.parent.removeEventListener("message", l, !1), o(d.data.value));
      };
      r.parent.addEventListener("message", a, !1), r.child.postMessage({
        postmate: "request",
        type: v,
        property: n,
        uid: i
      }, r.childOrigin);
    });
  }, e.call = function(n, r) {
    this.child.postMessage({
      postmate: "call",
      type: v,
      property: n,
      data: r
    }, this.childOrigin);
  }, e.on = function(n, r) {
    this.events[n] || (this.events[n] = []), this.events[n].push(r);
  }, e.destroy = function() {
    process.env.NODE_ENV !== "production" && c("Parent: Destroying Postmate instance"), window.removeEventListener("message", this.listener, !1), this.frame.parentNode.removeChild(this.frame);
  }, s;
}(), ue = /* @__PURE__ */ function() {
  function s(t) {
    var n = this;
    this.model = t.model, this.parent = t.parent, this.parentOrigin = t.parentOrigin, this.child = t.child, process.env.NODE_ENV !== "production" && (c("Child: Registering API"), c("Child: Awaiting messages...")), this.child.addEventListener("message", function(r) {
      if (B(r, n.parentOrigin)) {
        process.env.NODE_ENV !== "production" && c("Child: Received request", r.data);
        var o = r.data, i = o.property, a = o.uid, l = o.data;
        if (r.data.postmate === "call") {
          i in n.model && typeof n.model[i] == "function" && n.model[i](l);
          return;
        }
        ce(n.model, i).then(function(d) {
          return r.source.postMessage({
            property: i,
            postmate: "reply",
            type: v,
            uid: a,
            value: d
          }, r.origin);
        });
      }
    });
  }
  var e = s.prototype;
  return e.emit = function(n, r) {
    process.env.NODE_ENV !== "production" && c('Child: Emitting Event "' + n + '"', r), this.parent.postMessage({
      postmate: "emit",
      type: v,
      value: {
        name: n,
        data: r
      }
    }, this.parentOrigin);
  }, s;
}(), g = /* @__PURE__ */ function() {
  function s(t) {
    var n = t.container, r = n === void 0 ? typeof r < "u" ? r : document.body : n, o = t.model, i = t.url, a = t.name, l = t.classListArray, d = l === void 0 ? [] : l, h = t.frame;
    return this.parent = window, h ? this.frame = h : (this.frame = document.createElement("iframe"), this.frame.name = a || "", this.frame.classList.add.apply(this.frame.classList, d)), r.appendChild(this.frame), this.child = this.frame.contentWindow || this.frame.contentDocument.parentWindow, this.model = o || {}, this.sendHandshake(i);
  }
  var e = s.prototype;
  return e.sendHandshake = function(n) {
    var r = this, o = le(n), i = 0, a;
    return new s.Promise(function(l, d) {
      var h = function O(k) {
        return B(k, o) ? k.data.postmate === "handshake-reply" ? (clearInterval(a), process.env.NODE_ENV !== "production" && c("Parent: Received handshake reply from Child"), r.parent.removeEventListener("message", O, !1), r.childOrigin = k.origin, process.env.NODE_ENV !== "production" && c("Parent: Saving Child origin", r.childOrigin), l(new fe(r))) : (process.env.NODE_ENV !== "production" && c("Parent: Invalid handshake reply"), d("Failed handshake")) : !1;
      };
      r.parent.addEventListener("message", h, !1);
      var C = function() {
        i++, process.env.NODE_ENV !== "production" && c("Parent: Sending handshake attempt " + i, {
          childOrigin: o
        }), r.child.postMessage({
          postmate: "handshake",
          type: v,
          model: r.model
        }, o), i === se && clearInterval(a);
      }, I = function() {
        C(), a = setInterval(C, 500);
      };
      r.frame.attachEvent ? r.frame.attachEvent("onload", I) : r.frame.addEventListener("load", I), process.env.NODE_ENV !== "production" && c("Parent: Loading frame", {
        url: n
      }), r.frame.src = n;
    });
  }, s;
}();
g.debug = !1;
g.Promise = function() {
  try {
    return window ? window.Promise : Promise;
  } catch {
    return null;
  }
}();
g.Model = /* @__PURE__ */ function() {
  function s(t) {
    return this.child = window, this.model = t, this.parent = this.child.parent, this.sendHandshakeReply();
  }
  var e = s.prototype;
  return e.sendHandshakeReply = function() {
    var n = this;
    return new g.Promise(function(r, o) {
      var i = function a(l) {
        if (l.data.postmate) {
          if (l.data.postmate === "handshake") {
            process.env.NODE_ENV !== "production" && c("Child: Received handshake from Parent"), n.child.removeEventListener("message", a, !1), process.env.NODE_ENV !== "production" && c("Child: Sending handshake reply to Parent"), l.source.postMessage({
              postmate: "handshake-reply",
              type: v
            }, l.origin), n.parentOrigin = l.origin;
            var d = l.data.model;
            return d && (Object.keys(d).forEach(function(h) {
              n.model[h] = d[h];
            }), process.env.NODE_ENV !== "production" && c("Child: Inherited and extended model from Parent")), process.env.NODE_ENV !== "production" && c("Child: Saving Parent origin", n.parentOrigin), r(new ue(n));
          }
          return o("Handshake Reply Failed");
        }
      };
      n.child.addEventListener("message", i, !1);
    });
  }, s;
}();
class J {
  constructor(e, t, n) {
    E(this, "emitter");
    E(this, "container");
    E(this, "options");
    this.emitter = e, this.container = t, this.options = n || {};
  }
  createFrame() {
    const e = document.createElement("iframe");
    return e.name = "cfp-iframe", e.setAttribute("style", "position:absolute;top:0;left:0;width:100%;height:100%;border:0"), e;
  }
}
class he extends J {
  constructor() {
    super(...arguments);
    E(this, "parent");
  }
  async play(t, n) {
    return new Promise(async (r) => {
      const o = this.options.presentationAnimationEngineIframeUrl ? this.options.presentationAnimationEngineIframeUrl : `${this.options.engineBaseUrl ? this.options.engineBaseUrl : ""}/cf-player/presentation-engine/index.html`, i = await new g({
        container: this.container,
        // @ts-ignore
        frame: this.createFrame(),
        url: o,
        model: {
          playMetas: t.animation,
          defaultPage: n.defaultPage ? n.defaultPage : 1,
          defaultStep: n.defaultStep ? n.defaultStep : 1
        }
      });
      let a = !1;
      i.on("paginationChange", (l) => {
        this.emitter.emit("paginationChange", Object.assign(l, { total: t.page })), a || (a = !0, r());
      }), this.parent = i;
    });
  }
  async prev() {
    if (!this.parent)
      throw new Error("No postmate handshake.");
    await this.parent.get("prev");
  }
  async next() {
    if (!this.parent)
      throw new Error("No postmate handshake.");
    await this.parent.get("next");
  }
  async goto(t) {
    if (!this.parent)
      throw new Error("No postmate handshake.");
    t.step = t.step ? t.step : 1, this.parent.call("goto", t);
  }
  async destroy() {
    this.parent && this.parent.destroy();
  }
}
const m = /* @__PURE__ */ new WeakMap(), y = /* @__PURE__ */ new WeakMap(), p = /* @__PURE__ */ new WeakMap(), L = Symbol("anyProducer"), N = Promise.resolve(), D = Symbol("listenerAdded"), x = Symbol("listenerRemoved");
let V = !1, $ = !1;
const T = (s) => typeof s == "string" || typeof s == "symbol" || typeof s == "number";
function b(s) {
  if (!T(s))
    throw new TypeError("`eventName` must be a string, symbol, or number");
}
function M(s) {
  if (typeof s != "function")
    throw new TypeError("listener must be a function");
}
function P(s, e) {
  const t = y.get(s);
  if (t.has(e))
    return t.get(e);
}
function A(s, e) {
  const t = T(e) ? e : L, n = p.get(s);
  if (n.has(t))
    return n.get(t);
}
function pe(s, e, t) {
  const n = p.get(s);
  if (n.has(e))
    for (const r of n.get(e))
      r.enqueue(t);
  if (n.has(L)) {
    const r = Promise.all([e, t]);
    for (const o of n.get(L))
      o.enqueue(r);
  }
}
function q(s, e) {
  e = Array.isArray(e) ? e : [e];
  let t = !1, n = () => {
  }, r = [];
  const o = {
    enqueue(i) {
      r.push(i), n();
    },
    finish() {
      t = !0, n();
    }
  };
  for (const i of e) {
    let a = A(s, i);
    a || (a = /* @__PURE__ */ new Set(), p.get(s).set(i, a)), a.add(o);
  }
  return {
    async next() {
      return r ? r.length === 0 ? t ? (r = void 0, this.next()) : (await new Promise((i) => {
        n = i;
      }), this.next()) : {
        done: !1,
        value: await r.shift()
      } : { done: !0 };
    },
    async return(i) {
      r = void 0;
      for (const a of e) {
        const l = A(s, a);
        l && (l.delete(o), l.size === 0 && p.get(s).delete(a));
      }
      return n(), arguments.length > 0 ? { done: !0, value: await i } : { done: !0 };
    },
    [Symbol.asyncIterator]() {
      return this;
    }
  };
}
function F(s) {
  if (s === void 0)
    return H;
  if (!Array.isArray(s))
    throw new TypeError("`methodNames` must be an array of strings");
  for (const e of s)
    if (!H.includes(e))
      throw typeof e != "string" ? new TypeError("`methodNames` element must be a string") : new Error(`${e} is not Emittery method`);
  return s;
}
const _ = (s) => s === D || s === x;
function S(s, e, t) {
  if (_(e))
    try {
      V = !0, s.emit(e, t);
    } finally {
      V = !1;
    }
}
class w {
  static mixin(e, t) {
    return t = F(t), (n) => {
      if (typeof n != "function")
        throw new TypeError("`target` must be function");
      for (const i of t)
        if (n.prototype[i] !== void 0)
          throw new Error(`The property \`${i}\` already exists on \`target\``);
      function r() {
        return Object.defineProperty(this, e, {
          enumerable: !1,
          value: new w()
        }), this[e];
      }
      Object.defineProperty(n.prototype, e, {
        enumerable: !1,
        get: r
      });
      const o = (i) => function(...a) {
        return this[e][i](...a);
      };
      for (const i of t)
        Object.defineProperty(n.prototype, i, {
          enumerable: !1,
          value: o(i)
        });
      return n;
    };
  }
  static get isDebugEnabled() {
    var t;
    if (typeof ((t = globalThis.process) == null ? void 0 : t.env) != "object")
      return $;
    const { env: e } = globalThis.process ?? { env: {} };
    return e.DEBUG === "emittery" || e.DEBUG === "*" || $;
  }
  static set isDebugEnabled(e) {
    $ = e;
  }
  constructor(e = {}) {
    m.set(this, /* @__PURE__ */ new Set()), y.set(this, /* @__PURE__ */ new Map()), p.set(this, /* @__PURE__ */ new Map()), p.get(this).set(L, /* @__PURE__ */ new Set()), this.debug = e.debug ?? {}, this.debug.enabled === void 0 && (this.debug.enabled = !1), this.debug.logger || (this.debug.logger = (t, n, r, o) => {
      try {
        o = JSON.stringify(o);
      } catch {
        o = `Object with the following keys failed to stringify: ${Object.keys(o).join(",")}`;
      }
      (typeof r == "symbol" || typeof r == "number") && (r = r.toString());
      const i = /* @__PURE__ */ new Date(), a = `${i.getHours()}:${i.getMinutes()}:${i.getSeconds()}.${i.getMilliseconds()}`;
      console.log(`[${a}][emittery:${t}][${n}] Event Name: ${r}
	data: ${o}`);
    });
  }
  logIfDebugEnabled(e, t, n) {
    (w.isDebugEnabled || this.debug.enabled) && this.debug.logger(e, this.debug.name, t, n);
  }
  on(e, t) {
    M(t), e = Array.isArray(e) ? e : [e];
    for (const n of e) {
      b(n);
      let r = P(this, n);
      r || (r = /* @__PURE__ */ new Set(), y.get(this).set(n, r)), r.add(t), this.logIfDebugEnabled("subscribe", n, void 0), _(n) || S(this, D, { eventName: n, listener: t });
    }
    return this.off.bind(this, e, t);
  }
  off(e, t) {
    M(t), e = Array.isArray(e) ? e : [e];
    for (const n of e) {
      b(n);
      const r = P(this, n);
      r && (r.delete(t), r.size === 0 && y.get(this).delete(n)), this.logIfDebugEnabled("unsubscribe", n, void 0), _(n) || S(this, x, { eventName: n, listener: t });
    }
  }
  once(e) {
    let t;
    const n = new Promise((r) => {
      t = this.on(e, (o) => {
        t(), r(o);
      });
    });
    return n.off = t, n;
  }
  events(e) {
    e = Array.isArray(e) ? e : [e];
    for (const t of e)
      b(t);
    return q(this, e);
  }
  async emit(e, t) {
    if (b(e), _(e) && !V)
      throw new TypeError("`eventName` cannot be meta event `listenerAdded` or `listenerRemoved`");
    this.logIfDebugEnabled("emit", e, t), pe(this, e, t);
    const n = P(this, e) ?? /* @__PURE__ */ new Set(), r = m.get(this), o = [...n], i = _(e) ? [] : [...r];
    await N, await Promise.all([
      ...o.map(async (a) => {
        if (n.has(a))
          return a(t);
      }),
      ...i.map(async (a) => {
        if (r.has(a))
          return a(e, t);
      })
    ]);
  }
  async emitSerial(e, t) {
    if (b(e), _(e) && !V)
      throw new TypeError("`eventName` cannot be meta event `listenerAdded` or `listenerRemoved`");
    this.logIfDebugEnabled("emitSerial", e, t);
    const n = P(this, e) ?? /* @__PURE__ */ new Set(), r = m.get(this), o = [...n], i = [...r];
    await N;
    for (const a of o)
      n.has(a) && await a(t);
    for (const a of i)
      r.has(a) && await a(e, t);
  }
  onAny(e) {
    return M(e), this.logIfDebugEnabled("subscribeAny", void 0, void 0), m.get(this).add(e), S(this, D, { listener: e }), this.offAny.bind(this, e);
  }
  anyEvent() {
    return q(this);
  }
  offAny(e) {
    M(e), this.logIfDebugEnabled("unsubscribeAny", void 0, void 0), S(this, x, { listener: e }), m.get(this).delete(e);
  }
  clearListeners(e) {
    e = Array.isArray(e) ? e : [e];
    for (const t of e)
      if (this.logIfDebugEnabled("clear", t, void 0), T(t)) {
        const n = P(this, t);
        n && n.clear();
        const r = A(this, t);
        if (r) {
          for (const o of r)
            o.finish();
          r.clear();
        }
      } else {
        m.get(this).clear();
        for (const [n, r] of y.get(this).entries())
          r.clear(), y.get(this).delete(n);
        for (const [n, r] of p.get(this).entries()) {
          for (const o of r)
            o.finish();
          r.clear(), p.get(this).delete(n);
        }
      }
  }
  listenerCount(e) {
    var n, r, o;
    e = Array.isArray(e) ? e : [e];
    let t = 0;
    for (const i of e) {
      if (T(i)) {
        t += m.get(this).size + (((n = P(this, i)) == null ? void 0 : n.size) ?? 0) + (((r = A(this, i)) == null ? void 0 : r.size) ?? 0) + (((o = A(this)) == null ? void 0 : o.size) ?? 0);
        continue;
      }
      i !== void 0 && b(i), t += m.get(this).size;
      for (const a of y.get(this).values())
        t += a.size;
      for (const a of p.get(this).values())
        t += a.size;
    }
    return t;
  }
  bindMethods(e, t) {
    if (typeof e != "object" || e === null)
      throw new TypeError("`target` must be an object");
    t = F(t);
    for (const n of t) {
      if (e[n] !== void 0)
        throw new Error(`The property \`${n}\` already exists on \`target\``);
      Object.defineProperty(e, n, {
        enumerable: !1,
        value: this[n].bind(this)
      });
    }
  }
}
const H = Object.getOwnPropertyNames(w.prototype).filter((s) => s !== "constructor");
Object.defineProperty(w, "listenerAdded", {
  value: D,
  writable: !1,
  enumerable: !0,
  configurable: !1
});
Object.defineProperty(w, "listenerRemoved", {
  value: x,
  writable: !1,
  enumerable: !0,
  configurable: !1
});
class ge extends J {
  constructor() {
    super(...arguments);
    E(this, "postmate");
  }
  async play(t, n) {
    return new Promise(async (r) => {
      const o = this.options.imageEngineIframeUrl ? this.options.imageEngineIframeUrl : `${this.options.engineBaseUrl ? this.options.engineBaseUrl : ""}/cf-player/image-engine/index.html`, i = await new g({
        container: this.container,
        // @ts-ignore
        frame: this.createFrame(),
        url: o,
        model: {
          metas: t,
          defaultPage: n.defaultPage ? n.defaultPage : 1,
          vertical: n.vertical ? n.vertical : !1
        }
      });
      let a = !1;
      i.on("paginationChange", (l) => {
        console.warn("paginationChange"), this.emitter.emit("paginationChange", l), a || (a = !0, setTimeout(() => {
          console.warn("played"), r();
        }, 500));
      }), this.postmate = i;
    });
  }
  async prev() {
    if (!this.postmate)
      throw new Error("No postmate handshake.");
    await this.postmate.get("prev");
  }
  async next() {
    if (!this.postmate)
      throw new Error("No postmate handshake.");
    await this.postmate.get("next");
  }
  async goto(t) {
    if (!this.postmate)
      throw new Error("No postmate handshake.");
    this.postmate.call("goto", t);
  }
  async destroy() {
    this.postmate && this.postmate.destroy();
  }
}
const me = { class: "cf-player" }, we = /* @__PURE__ */ W({
  __name: "Player",
  props: {
    file: {},
    engine: { default: "image" },
    defaultPage: { default: 1 },
    defaultStep: { default: 1 },
    vertical: { type: Boolean, default: !1 },
    dark: { type: Boolean, default: !1 },
    engineBaseUrl: {},
    imageEngineIframeUrl: {},
    presentationAnimationEngineIframeUrl: {}
  },
  emits: ["paginationChange"],
  setup(s, { expose: e, emit: t }) {
    const n = s, r = t, o = U(null), i = z(null), a = z(null), l = new w();
    l.on("paginationChange", (f) => {
      r("paginationChange", f);
    });
    const d = U(!1);
    Y([() => n.file, () => n.engine], async () => {
      if (n.file) {
        if (typeof n.file == "string")
          throw new Error("File id is not supported, but coming soon...");
        a.value = n.file, a.value && (d.value = !0, await k(a.value, n.engine), await i.value.play(Z(a.value), {
          defaultPage: n.defaultPage,
          defaultStep: n.defaultStep,
          vertical: n.vertical
        }), d.value = !1);
      }
    }, { immediate: !0 });
    const h = async () => {
      if (!i.value)
        throw new Error("No engine.");
      await i.value.prev();
    }, C = async () => {
      if (!i.value)
        throw new Error("No engine.");
      await i.value.next();
    }, I = async (f) => {
      if (!i.value)
        throw new Error("No engine.");
      await i.value.goto(f);
    }, O = () => {
      if (!a.value || !a.value.page || !a.value.thumb)
        return [];
      const f = [];
      for (let u = 1; u <= a.value.page; u++)
        f.push({ page: u, url: a.value.thumb + u });
      return f;
    }, k = async (f, u) => {
      if (await K(), f.type === "Presentation")
        u === "image" ? i.value = new ge(l, o.value, n) : u === "presentation" && (i.value = new he(l, o.value, n));
      else throw f.type === "Word" ? new Error("Coming soon.") : f.type === "PDF" ? new Error("Coming soon.") : new Error("Not support file type.");
    }, K = async () => {
      i.value && (await i.value.destroy(), i.value = null);
    };
    return e({
      prev: h,
      next: C,
      goto: I,
      thumbs: O
    }), (f, u) => (R(), j("div", me, [
      ee("div", {
        ref_key: "container",
        ref: o,
        class: "cf-player__container"
      }, null, 512),
      d.value ? (R(), j("div", {
        key: 0,
        class: G(["cf-player__mask", { "cf-player__mask--dark": f.dark }])
      }, [
        te(ie),
        u[0] || (u[0] = ne(" 文件加载中... "))
      ], 2)) : re("", !0)
    ]));
  }
});
export {
  we as CloudFilePlayer
};
